pragma solidity ^0.4.8;

/// @title Safe Math Operations
/// @author Open Zeppelin

library SafeMath {

  function assert(bool assertion) internal {
    if (!assertion) {
      throw;
    }
  }

  function safeSub(uint a, uint b) internal returns (uint) {
    assert(b <= a);
    return a - b;
  }

  function safeAdd(uint a, uint b) internal returns (uint) {
    uint c = a + b;
    assert(c>=a && c>=b);
    return c;
  }

  function safeMul(uint a, uint b) internal returns (uint) {
    uint c = a * b;
    assert(a == 0 || c / a == b);
    return c;
  }
}
